#include "p16f18875.inc"


 __CONFIG _CONFIG1, _FEXTOSC_OFF & _RSTOSC_HFINT32 & _CLKOUTEN_OFF & _CSWEN_OFF & _FCMEN_OFF
 __CONFIG _CONFIG2, _MCLRE_ON & _PWRTE_OFF & _LPBOREN_OFF & _BOREN_ON & _BORV_LO & _ZCD_OFF & _PPS1WAY_OFF & _STVREN_ON
 __CONFIG _CONFIG3, _WDTCPS_WDTCPS_31 & _WDTE_OFF & _WDTCWS_WDTCWS_7 & _WDTCCS_SC
 __CONFIG _CONFIG4, _WRT_OFF & _SCANE_available & _LVP_ON
 __CONFIG _CONFIG5, _CP_OFF & _CPD_OFF


Bank0vars   UDATA	 0x20 ;valtozok ramban 0 bankban fix cimtol
Datareg	RES	1
valtozo	RES	1
DTMP1	RES	1	; ciklus vltoz
DTMP2	RES	1	; ciklus vltoz
	
 
RES_VECT:  CODE    0x0000            ; reset vektor helye
    GOTO    START                   ; valodi foprogram kezdete

ISR:       CODE    0x0004           ; interrupt vektor helye
    GOTO ISR_FUNC		    ;valodi megszakts rutin
    
MAIN_PROG CODE                      ; f?program kvetkezik

START:
    BANKSEL ANSELA
    CLRF    ANSELA
    BSF	    ANSELA,0 ;A0 a poti
    CLRF    ANSELB   ;minden mas portlab digitalis
    CLRF    ANSELC
    CLRF    ANSELD
    BANKSEL TRISA  ;innentol minden 0-s bankban van
    MOVLW   0x0F   ;A4-5-6-7 ledek kimenetre allitasa
    MOVWF   TRISA
    
    ;tovabbi inicializalasok helye
    
    ;BSF    INTCON,GIE  
    ;BSF    INTCON,PEIE ;Megszaktsok engedlyezse, ha kell
    ;BANKSEL PIE0
    ;BSF    PIE0,TMR0IE
    ;BANKSEL LATA
MAINLOOP:  ;fociklus
 
    
    BRA    MAINLOOP ;fociklus vege

    
    
ISR_FUNC:  ;megszakitasi szubrutin
    BANKSEL PIR0
    MOVF    PIR0,W ;milyen IT-k vannak
    ANDWF   PIE0,W   ;s ezek kzl mik engedlyezettek?
    BTFSS   WREG,TMR0IF ;ha a TMR0IF helyen mg 1-es van akkor az jtt
    BRA	    IT_VEGE
    BCF	    PIR0,TMR0IF ;Letrljk a flaget
    BANKSEL valtozo ;visszavltunk, hogy lssuk a vltozkat
    ;Ide jhet a timer0 megszaktsi szubrutinja
    
IT_VEGE:    
    RETFIE
 
;tovbbi szubrutinok helye:    
    
    
    
; nehany pelda szubrutin:
Delay10us: ; 125ns/ciklus@Fosc=32MHz-->8MHZ instructionclock
    MOVLW   D'25'	; 3
D10CK:
    DECFSZ  WREG,W	; 1 /2
    GOTO    D10CK	; 2
    RETURN		; 2
    
Delay1ms:
    MOVLW   D'98'
    MOVWF   DTMP1
D1MSCK:
    CALL    Delay10us
    DECFSZ  DTMP1,F
    GOTO    D1MSCK
    RETURN
    
Delay250ms:
    MOVLW   D'249'
    MOVWF   DTMP2
D250MSCK:
    CALL    Delay1ms
    DECFSZ  DTMP2,F
    GOTO    D250MSCK
    RETURN

LAMP_KOD:
    ANDLW H'03'
    BRW
    RETLW B'00000100';P
    RETLW B'10000100';PS
    RETLW B'00010000';Z
    RETLW B'10000000';S

LAMP_STAT:
    ANDLW H'07' ; als 3 bit meghagysa
    BRW
    RETLW H'00' ; P - P
    RETLW H'10' ; PS - P
    RETLW H'20' ; Z - P
    RETLW H'30' ; S - P
    RETLW H'00' ; P - P
    RETLW H'01' ; P - PS
    RETLW H'02' ; P - Z
    RETLW H'03' ; P - S
    
    
NUMTO7SEG:		;W-ben szam, visszatereskor 7seg data
    ANDLW H'0F'
    BRW		;a konstansra ugras visszater
    RETLW   H'7E';'0'
    RETLW   H'0A'; '1'    _a_
    RETLW   H'B6'; '2'  f|   |b
    RETLW   H'9E'; '3'   |_g_|
    RETLW   H'CA'; '4'  e|   |c
    RETLW   H'DC'; '5'   |_d_|.dp
    RETLW   H'FC'; '6'
    RETLW   H'0E'; '7'
    RETLW   H'FE'; '8'
    RETLW   H'DE'; '9'
    RETLW   H'EE'; 'A'
    RETLW   H'F8'; 'B'
    RETLW   H'74'; 'C'
    RETLW   H'BA'; 'D'
    RETLW   H'F4'; 'E'
    RETLW   H'E4'; 'F    
    
   
 END